#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
#include <EEPROM.h>
#include <Wire.h>                                   // I2C -Bibliothek 
#include "Index.h"                                  // Enthaelt HTML-Code der Index Webseite 
// const char indexHtml[5423]={};
char ssid[32] = "1234\0";
char passphrase[64] = "567890\0";
char output = 0;                                    // Schltzustaende
char IC = 32;                                       // Adresse des I2C ICs
int i, port;
ESP8266WebServer *server;                           //Zeiger auf Objekt Klasse Server
EspClass esp;                                       // Objekt esp um Reset zu machen

void setup()                // Wird 1 Mal beim Start ausgefuehrt
{
  Wire.begin(2, 0);                                 // I2C-Bus initialisieren GPIO2-Data GPIO0-Clock
  Wire.setClock(1000);                              // I2C-Bus Freqenz
  Wire.requestFrom(IC, 1);    // 
  while (Wire.available())   i = Wire.read(); // receive a byte as character


  // Anfangszustand 1111 11111 (Relais ausgeschaltet)
  //Wire.beginTransmission(IC);                       // IC-Adresse
  //Wire.write(~output);                              // Byte senden Daten werden Inveriert
  //Wire.endTransmission();                           // I2C Stopbedingung

  Serial.begin(115200);
  Serial.println("\r\n") ;

  EEPROM.begin(66);                                 // EEPROM initialisieren mit 64 Byts
sprungmarke:

  // Eeeprom einlesen
  for (i = 0; i < 32; i++) ssid[i] = EEPROM.read(i);
  for (i = 32; i < 64; i++) passphrase[i - 32] = EEPROM.read(i);
  port = EEPROM.read(64);
  port += EEPROM.read(65) * 256;

  // Wenn EEPROM leer
  if (ssid[0] == 255)
  {
    Serial.println("SSID nicht konfiguriert\r\n") ;
    Serial.println("Weiter mit \"Enter\"\r\n") ;
    while (!Serial.available())yield();             // Warte bis Seriell etwas reinkommt
    InputEEPR();                                    // Unterprogramm zum configurieren der WiFi
    goto sprungmarke;
  }

  WiFi.mode(WIFI_STA);                              // Station Modus
  WiFi.begin(ssid, passphrase);
  while (WiFi.status() != WL_CONNECTED)             // Warten auf verbindung
  {
    delay(500);
    Serial.print(".");
    if (Serial.available()) InputEEPR();            // Ausgang wenn Seriell etwas empfangen
  }                                                 // dann Wlan Name und Passwort eingeben
  server = new ESP8266WebServer(port);              // Objekt Server Bilden und dem Zeiger Uebergeben
  Serial.println("");
  Serial.print("Verbunden mit ");
  Serial.println(ssid);
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());

  //  Bechandlung der Ereignissen anschlissen
  server->on("/", Ereignis_Index);
  server->on("/schalte.php", Ereignis_Befehl);

  server->begin();  // Starte den Server
  Serial.print("HTTP Server gestartet am Port: ");
  Serial.println(port);
  
  Wire.requestFrom(IC, 1);    // Aktueller Wert einlesen
  output = ~Wire.read(); // receive a byte as character
  Serial.print("Relais: ");
  Serial.println(int(output));
}

void Ereignis_Befehl()      // Wird ausgefuehrt wenn "http://<ip address>/schalte.php" aufgerufen wurde
{
  String relaisNr = server->arg("relais");          // Relais Nr. empfangen
  int z = relaisNr.toInt();                         // String zu Integer konvertieren
  z--;                                              // 1 abzien, weil bits im Byte werden ab 0 gezaelt
  String zustand = server->arg("schalte");
  if (zustand == "1") bitSet(output, z);            // Wenn Einschalten gewuenscht Bit setzen 
  if (zustand == "0") bitClear(output, z);          // Wenn Ausschalten gewuenscht Bit zuruecksetzen 
  char k = 0;                                       // Temporere Variable fuer XOR Operation
  if (zustand == "2") output ^= bitSet(k, z);       // Umschalten den gewaelten Relay mit XOR
  Wire.beginTransmission(IC);                       // I2C IC-Adresse
  Wire.write(~output);                              // Byte Invertieren und senden Relais werden mit "0" geschaltet
  Wire.endTransmission();                           // Stop-Bedingung I2C
  // Serial.println(String(int(output)));
  server->send(200, "text/plain", String(int(output)) ); // Antwort an Internet Browser senden
}

void Ereignis_Index()       // Wird ausgefuehrt wenn "http://<ip address>/" aufgerufen wurde
{
  server->send(200, "text/html", indexHtml);        // HTML Webseie befindet sich im "Index.h"
}

void loop()
{
  if (Serial.available()) InputEEPR();              // Wenn Seriell etwas empfangen
  server->handleClient();                           // Server Ereignisse abarbeiten
}

void InputEEPR()            //Hier wird Wlan-Zugang sowie Port konfiguriert
{
  String Text = "";                                 // Variable für Port Nummer als Text
  char inser;                                       // Variable für RS232-Empfangene Zeichen
  inser = Serial.read();
  if (inser != 13)  return;                         // Wenn NICHT "Enter" dann Unterprogramm verlassen
schleife:
  Serial.println("");
  Serial.println("Bitte auswaelen zum aendern");
  Serial.print("1. SSID:       ");
  Serial.println(ssid);
  Serial.print("2. Passwort:   ");
  Serial.println(passphrase);
  Serial.print("3. Serverport: ");
  Serial.println(port);
  Serial.println("4. Ausgang");
  Serial.println("5. Reset");
  Serial.println("");
  while (!Serial.available()) yield();              // Warte bis etwas empfangen wird
  inser = Serial.read();                            // Auswahl empfangen
  switch (inser)                                    // Zutreffendes ausfuehren
  {
    case '1':
      Serial.println("Input SSID: ");
      for (i = 0; i < 32; i++)
      {
        while (!Serial.available()) yield();       //warte bis etwas empfangen wird
        inser = Serial.read();
        Serial.write(inser);
        if (inser == '\r')                          // Wenn Zeile abgeschlossen ist
        {
          EEPROM.write(i, '\0');                    // Stringende setzen
          break;                                    // for schleife verlassen
        } else  EEPROM.write(i, inser);             // nechste Zeichen empfangen
      }
      Serial.println("\r\nOK");
      EEPROM.commit();                              // EEPROM fuesikalisch beschreiben
      for (i = 0; i < 32; i++) ssid[i] = EEPROM.read(i); // Neue Daten in Variablen laden
      break;

    case '2':
      Serial.println("Input Passwort: ");
      for (i = 32; i < 64; i++)
      {
        while (!Serial.available()) yield();
        inser = Serial.read();
        Serial.write(inser);
        if (inser == '\r')
        {
          EEPROM.write(i, '\0');
          break;
        } else EEPROM.write(i, inser);
      }
      Serial.println("\r\nOK");
      EEPROM.commit();
      for (i = 32; i < 64; i++) passphrase[i - 32] = EEPROM.read(i);
      break;

    case '3':
      Serial.println("Input Port: ");
      for (i = 0; i < 5; i++)
      {
        while (!Serial.available()) yield();        // warte bis etwas empfangen wird
        inser = Serial.read();
        Serial.write(inser);
        if (inser == '\r') break;                   // Wenn zeile abgeschlossen ist for schleife verlassen
        else Text += (char)inser;
      }
      Text += '\0';                                 // Stringende setzen
      Serial.println("\r\nOK");
      port = Text.toInt();                          // Integer aus Text bilden
      char* p;
      p = reinterpret_cast<char*>(&port);           // Byte array aus Integer machen
      EEPROM.write(64, p[0]);                       // und im EEPROM speichern
      EEPROM.write(65, p[1]);
      EEPROM.commit();
      port = EEPROM.read(64);                       // Neue Daten in Variablen laden
      port += EEPROM.read(65) * 256;
      break;

    case '4':
      WiFi.begin(ssid, passphrase);
      return;                                       // Unterprogramm InputEEPR() verlassen
      break;
    case '5':
      esp.reset();
      break;
    default:
      break;
  }
  goto schleife;                                    // Nach der Eingabe wieder zum Menu zurueckkehren
}

